"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

class ReturnCode(google.protobuf.message.Message):
    """*
    Status response of a message. A value of 0 indicates a successful request.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    VALUE_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    value: builtins.int = ...
    """Status code of response. A value of 0 indicates success."""

    message: typing.Text = ...
    """Message indicating the status of response including any error."""

    def __init__(self,
        *,
        value : builtins.int = ...,
        message : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["message",b"message","value",b"value"]) -> None: ...
global___ReturnCode = ReturnCode

class ExitRequest(google.protobuf.message.Message):
    """*
    Empty request to exit the gRPC connection.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    CLOSESHERLOCKCLIENT_FIELD_NUMBER: builtins.int
    closeSherlockClient: builtins.bool = ...
    """If set to true, exits the Sherlock client if it is opened. Otherwise, just closes the gRPC connection."""

    def __init__(self,
        *,
        closeSherlockClient : builtins.bool = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["closeSherlockClient",b"closeSherlockClient"]) -> None: ...
global___ExitRequest = ExitRequest

class HealthCheckRequest(google.protobuf.message.Message):
    """*
    Empty request to check if the gRPC connection is open.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___HealthCheckRequest = HealthCheckRequest

class HealthCheckResponse(google.protobuf.message.Message):
    """*
    Represents whether the gRPC connection is open.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class _ServingStatus:
        ValueType = typing.NewType('ValueType', builtins.int)
        V: typing_extensions.TypeAlias = ValueType
    class _ServingStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ServingStatus.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor = ...
        UNKNOWN: HealthCheckResponse.ServingStatus.ValueType = ...  # 0
        """Indicates an unknown connection status."""

        SERVING: HealthCheckResponse.ServingStatus.ValueType = ...  # 1
        """Indicates the connection is up and server is listening."""

        NOT_SERVING: HealthCheckResponse.ServingStatus.ValueType = ...  # 2
        """Indicates connection with server is closed."""

    class ServingStatus(_ServingStatus, metaclass=_ServingStatusEnumTypeWrapper):
        pass

    UNKNOWN: HealthCheckResponse.ServingStatus.ValueType = ...  # 0
    """Indicates an unknown connection status."""

    SERVING: HealthCheckResponse.ServingStatus.ValueType = ...  # 1
    """Indicates the connection is up and server is listening."""

    NOT_SERVING: HealthCheckResponse.ServingStatus.ValueType = ...  # 2
    """Indicates connection with server is closed."""


    STATUS_FIELD_NUMBER: builtins.int
    PORT_FIELD_NUMBER: builtins.int
    status: global___HealthCheckResponse.ServingStatus.ValueType = ...
    port: builtins.int = ...
    """Listening port number on server."""

    def __init__(self,
        *,
        status : global___HealthCheckResponse.ServingStatus.ValueType = ...,
        port : builtins.int = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["port",b"port","status",b"status"]) -> None: ...
global___HealthCheckResponse = HealthCheckResponse

class IsSherlockClientLoadingRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___IsSherlockClientLoadingRequest = IsSherlockClientLoadingRequest

class ListUnitsRequest(google.protobuf.message.Message):
    """*
    Request for a list of valid units of the provided unit type.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class _UnitType:
        ValueType = typing.NewType('ValueType', builtins.int)
        V: typing_extensions.TypeAlias = ValueType
    class _UnitTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_UnitType.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor = ...
        UNKNOWN: ListUnitsRequest.UnitType.ValueType = ...  # 0
        """Indicates an unknown unit type."""

        ACCEL_DENSITY: ListUnitsRequest.UnitType.ValueType = ...  # 1
        """Units used for acceleration density."""

        ACCELERATION: ListUnitsRequest.UnitType.ValueType = ...  # 2
        """Units used for acceleration."""

        AREA: ListUnitsRequest.UnitType.ValueType = ...  # 3
        """Units used for area."""

        BANDWIDTH: ListUnitsRequest.UnitType.ValueType = ...  # 4
        """Units used for bandwidth."""

        CAPACITANCE: ListUnitsRequest.UnitType.ValueType = ...  # 5
        """Units used for electrical capacitance."""

        CTE: ListUnitsRequest.UnitType.ValueType = ...  # 6
        """Units used for material CTE."""

        CURRENT: ListUnitsRequest.UnitType.ValueType = ...  # 7
        """Units used for electrical current."""

        DENSITY: ListUnitsRequest.UnitType.ValueType = ...  # 8
        """Units used for density."""

        DISP_DENSITY: ListUnitsRequest.UnitType.ValueType = ...  # 9
        """Units used for displacement density."""

        FORCE: ListUnitsRequest.UnitType.ValueType = ...  # 10
        """Units used for force."""

        FREQUENCY: ListUnitsRequest.UnitType.ValueType = ...  # 11
        """Units used for frequency."""

        INDUCTANCE: ListUnitsRequest.UnitType.ValueType = ...  # 12
        """Units used for inductance."""

        LENGTH: ListUnitsRequest.UnitType.ValueType = ...  # 13
        """Units used for length."""

        POWER: ListUnitsRequest.UnitType.ValueType = ...  # 14
        """Units used for electrical power."""

        RESISTANCE: ListUnitsRequest.UnitType.ValueType = ...  # 15
        """Units used for electrical resistance."""

        SIZE: ListUnitsRequest.UnitType.ValueType = ...  # 16
        """Units used for size."""

        SPECIFIC_HEAT: ListUnitsRequest.UnitType.ValueType = ...  # 17
        """Units used for specific heat."""

        STRAIN: ListUnitsRequest.UnitType.ValueType = ...  # 18
        """Units used for strain."""

        STRESS: ListUnitsRequest.UnitType.ValueType = ...  # 19
        """Units used for stress."""

        TEMPERATURE: ListUnitsRequest.UnitType.ValueType = ...  # 20
        """Units used for temperature."""

        THERMAL_CONDUCTIVITY: ListUnitsRequest.UnitType.ValueType = ...  # 21
        """Units used for thermal conductivity."""

        THERMAL_RESISTANCE: ListUnitsRequest.UnitType.ValueType = ...  # 22
        """Units used for thermal resistance."""

        TIME: ListUnitsRequest.UnitType.ValueType = ...  # 23
        """Units used for time."""

        VELOCITY: ListUnitsRequest.UnitType.ValueType = ...  # 24
        """Units used for velocity."""

        VELOCITY_DENSITY: ListUnitsRequest.UnitType.ValueType = ...  # 25
        """Units used for velocity density."""

        VOLTAGE: ListUnitsRequest.UnitType.ValueType = ...  # 26
        """Units used for electrical voltage."""

        VOLUME: ListUnitsRequest.UnitType.ValueType = ...  # 27
        """Units used for volume."""

        WEIGHT: ListUnitsRequest.UnitType.ValueType = ...  # 28
        """Units used for weight."""

    class UnitType(_UnitType, metaclass=_UnitTypeEnumTypeWrapper):
        pass

    UNKNOWN: ListUnitsRequest.UnitType.ValueType = ...  # 0
    """Indicates an unknown unit type."""

    ACCEL_DENSITY: ListUnitsRequest.UnitType.ValueType = ...  # 1
    """Units used for acceleration density."""

    ACCELERATION: ListUnitsRequest.UnitType.ValueType = ...  # 2
    """Units used for acceleration."""

    AREA: ListUnitsRequest.UnitType.ValueType = ...  # 3
    """Units used for area."""

    BANDWIDTH: ListUnitsRequest.UnitType.ValueType = ...  # 4
    """Units used for bandwidth."""

    CAPACITANCE: ListUnitsRequest.UnitType.ValueType = ...  # 5
    """Units used for electrical capacitance."""

    CTE: ListUnitsRequest.UnitType.ValueType = ...  # 6
    """Units used for material CTE."""

    CURRENT: ListUnitsRequest.UnitType.ValueType = ...  # 7
    """Units used for electrical current."""

    DENSITY: ListUnitsRequest.UnitType.ValueType = ...  # 8
    """Units used for density."""

    DISP_DENSITY: ListUnitsRequest.UnitType.ValueType = ...  # 9
    """Units used for displacement density."""

    FORCE: ListUnitsRequest.UnitType.ValueType = ...  # 10
    """Units used for force."""

    FREQUENCY: ListUnitsRequest.UnitType.ValueType = ...  # 11
    """Units used for frequency."""

    INDUCTANCE: ListUnitsRequest.UnitType.ValueType = ...  # 12
    """Units used for inductance."""

    LENGTH: ListUnitsRequest.UnitType.ValueType = ...  # 13
    """Units used for length."""

    POWER: ListUnitsRequest.UnitType.ValueType = ...  # 14
    """Units used for electrical power."""

    RESISTANCE: ListUnitsRequest.UnitType.ValueType = ...  # 15
    """Units used for electrical resistance."""

    SIZE: ListUnitsRequest.UnitType.ValueType = ...  # 16
    """Units used for size."""

    SPECIFIC_HEAT: ListUnitsRequest.UnitType.ValueType = ...  # 17
    """Units used for specific heat."""

    STRAIN: ListUnitsRequest.UnitType.ValueType = ...  # 18
    """Units used for strain."""

    STRESS: ListUnitsRequest.UnitType.ValueType = ...  # 19
    """Units used for stress."""

    TEMPERATURE: ListUnitsRequest.UnitType.ValueType = ...  # 20
    """Units used for temperature."""

    THERMAL_CONDUCTIVITY: ListUnitsRequest.UnitType.ValueType = ...  # 21
    """Units used for thermal conductivity."""

    THERMAL_RESISTANCE: ListUnitsRequest.UnitType.ValueType = ...  # 22
    """Units used for thermal resistance."""

    TIME: ListUnitsRequest.UnitType.ValueType = ...  # 23
    """Units used for time."""

    VELOCITY: ListUnitsRequest.UnitType.ValueType = ...  # 24
    """Units used for velocity."""

    VELOCITY_DENSITY: ListUnitsRequest.UnitType.ValueType = ...  # 25
    """Units used for velocity density."""

    VOLTAGE: ListUnitsRequest.UnitType.ValueType = ...  # 26
    """Units used for electrical voltage."""

    VOLUME: ListUnitsRequest.UnitType.ValueType = ...  # 27
    """Units used for volume."""

    WEIGHT: ListUnitsRequest.UnitType.ValueType = ...  # 28
    """Units used for weight."""


    UNITTYPE_FIELD_NUMBER: builtins.int
    unitType: global___ListUnitsRequest.UnitType.ValueType = ...
    """Unit type to request valid units of."""

    def __init__(self,
        *,
        unitType : global___ListUnitsRequest.UnitType.ValueType = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["unitType",b"unitType"]) -> None: ...
global___ListUnitsRequest = ListUnitsRequest

class ListUnitsResponse(google.protobuf.message.Message):
    """*
    Represents a list of valid units for the provided unit type.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    RETURNCODE_FIELD_NUMBER: builtins.int
    UNITS_FIELD_NUMBER: builtins.int
    @property
    def returnCode(self) -> global___ReturnCode:
        """Status code of response."""
        pass
    @property
    def units(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[typing.Text]:
        """List of valid units for the requested type."""
        pass
    def __init__(self,
        *,
        returnCode : typing.Optional[global___ReturnCode] = ...,
        units : typing.Optional[typing.Iterable[typing.Text]] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["returnCode",b"returnCode"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["returnCode",b"returnCode","units",b"units"]) -> None: ...
global___ListUnitsResponse = ListUnitsResponse
