"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import ansys.api.sherlock.v0.SherlockCommonService_pb2
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

class GenReportRequest(google.protobuf.message.Message):
    """*
    Request for project report.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    PROJECT_FIELD_NUMBER: builtins.int
    AUTHOR_FIELD_NUMBER: builtins.int
    COMPANY_FIELD_NUMBER: builtins.int
    project: typing.Text = ...
    """Sherlock project name."""

    author: typing.Text = ...
    """Name of the author who generates the report."""

    company: typing.Text = ...
    """Name of author's company."""

    def __init__(self,
        *,
        project : typing.Text = ...,
        author : typing.Text = ...,
        company : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["author",b"author","company",b"company","project",b"project"]) -> None: ...
global___GenReportRequest = GenReportRequest

class GenReportResponse(google.protobuf.message.Message):
    """*
    Streams the project report in chunks.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    CONTENT_FIELD_NUMBER: builtins.int
    SIZE_FIELD_NUMBER: builtins.int
    RETURNCODE_FIELD_NUMBER: builtins.int
    content: builtins.bytes = ...
    """A chunk of the project report being returned in increments."""

    size: builtins.int = ...
    """Size of the chunk returned."""

    @property
    def returnCode(self) -> ansys.api.sherlock.v0.SherlockCommonService_pb2.ReturnCode:
        """Status code of response."""
        pass
    def __init__(self,
        *,
        content : builtins.bytes = ...,
        size : builtins.int = ...,
        returnCode : typing.Optional[ansys.api.sherlock.v0.SherlockCommonService_pb2.ReturnCode] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["returnCode",b"returnCode"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["content",b"content","returnCode",b"returnCode","size",b"size"]) -> None: ...
global___GenReportResponse = GenReportResponse

class GenCCAReportRequest(google.protobuf.message.Message):
    """*
    Request for project CCA report.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    PROJECT_FIELD_NUMBER: builtins.int
    CCA_FIELD_NUMBER: builtins.int
    AUTHOR_FIELD_NUMBER: builtins.int
    COMPANY_FIELD_NUMBER: builtins.int
    project: typing.Text = ...
    """Sherlock project name."""

    cca: typing.Text = ...
    """Project CCA name."""

    author: typing.Text = ...
    """Name of the author who generates the report."""

    company: typing.Text = ...
    """Name of author's company."""

    def __init__(self,
        *,
        project : typing.Text = ...,
        cca : typing.Text = ...,
        author : typing.Text = ...,
        company : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["author",b"author","cca",b"cca","company",b"company","project",b"project"]) -> None: ...
global___GenCCAReportRequest = GenCCAReportRequest

class GenCCAReportResponse(google.protobuf.message.Message):
    """*
    Streams the project CCA report in chunks.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    CONTENT_FIELD_NUMBER: builtins.int
    SIZE_FIELD_NUMBER: builtins.int
    RETURNCODE_FIELD_NUMBER: builtins.int
    content: builtins.bytes = ...
    """A chunk of the project CCA report being returned in increments."""

    size: builtins.int = ...
    """Size of the chunk returned."""

    @property
    def returnCode(self) -> ansys.api.sherlock.v0.SherlockCommonService_pb2.ReturnCode:
        """Status code of response."""
        pass
    def __init__(self,
        *,
        content : builtins.bytes = ...,
        size : builtins.int = ...,
        returnCode : typing.Optional[ansys.api.sherlock.v0.SherlockCommonService_pb2.ReturnCode] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["returnCode",b"returnCode"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["content",b"content","returnCode",b"returnCode","size",b"size"]) -> None: ...
global___GenCCAReportResponse = GenCCAReportResponse

class ImportODBRequest(google.protobuf.message.Message):
    """*
    Request for importing an ODB++ archive.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    ARCHIVEFILE_FIELD_NUMBER: builtins.int
    PROJECT_FIELD_NUMBER: builtins.int
    CCANAME_FIELD_NUMBER: builtins.int
    PROCESSLAYERTHICKNESS_FIELD_NUMBER: builtins.int
    INCLUDEOTHERLAYERS_FIELD_NUMBER: builtins.int
    PROCESSCUTOUTFILE_FIELD_NUMBER: builtins.int
    GUESSPARTPROPERTIES_FIELD_NUMBER: builtins.int
    IMSSTACKUP_FIELD_NUMBER: builtins.int
    archiveFile: typing.Text = ...
    """Full path to the ODB++ archive file to be imported."""

    project: typing.Text = ...
    """Sherlock project name. If empty, the filename will be used for the project name."""

    ccaName: typing.Text = ...
    """Project CCA name. If empty, the filename will be used for the CCA name."""

    processLayerThickness: builtins.bool = ...
    """Option to assign stackup  thickness."""

    includeOtherLayers: builtins.bool = ...
    """Option to include other layers."""

    processCutoutFile: builtins.bool = ...
    """Option to process cutouts."""

    guessPartProperties: builtins.bool = ...
    """Option to guess part properties"""

    imsStackup: builtins.bool = ...
    """Option to generate IMS stackup."""

    def __init__(self,
        *,
        archiveFile : typing.Text = ...,
        project : typing.Text = ...,
        ccaName : typing.Text = ...,
        processLayerThickness : builtins.bool = ...,
        includeOtherLayers : builtins.bool = ...,
        processCutoutFile : builtins.bool = ...,
        guessPartProperties : builtins.bool = ...,
        imsStackup : builtins.bool = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["archiveFile",b"archiveFile","ccaName",b"ccaName","guessPartProperties",b"guessPartProperties","imsStackup",b"imsStackup","includeOtherLayers",b"includeOtherLayers","processCutoutFile",b"processCutoutFile","processLayerThickness",b"processLayerThickness","project",b"project"]) -> None: ...
global___ImportODBRequest = ImportODBRequest

class ImportIPC2581Request(google.protobuf.message.Message):
    """*
    Request for importing an IPC-2581 archive.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    ARCHIVEFILE_FIELD_NUMBER: builtins.int
    PROJECT_FIELD_NUMBER: builtins.int
    CCANAME_FIELD_NUMBER: builtins.int
    INCLUDEOTHERLAYERS_FIELD_NUMBER: builtins.int
    GUESSPARTPROPERTIES_FIELD_NUMBER: builtins.int
    archiveFile: typing.Text = ...
    """Full path to the IPC-2581 archive file to be imported."""

    project: typing.Text = ...
    """Sherlock project name. If empty, the filename will be used for the project name."""

    ccaName: typing.Text = ...
    """Project CCA name. If empty, the filename will be used for the CCA name."""

    includeOtherLayers: builtins.bool = ...
    """Option to include other layers."""

    guessPartProperties: builtins.bool = ...
    """Option to guess part properties"""

    def __init__(self,
        *,
        archiveFile : typing.Text = ...,
        project : typing.Text = ...,
        ccaName : typing.Text = ...,
        includeOtherLayers : builtins.bool = ...,
        guessPartProperties : builtins.bool = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["archiveFile",b"archiveFile","ccaName",b"ccaName","guessPartProperties",b"guessPartProperties","includeOtherLayers",b"includeOtherLayers","project",b"project"]) -> None: ...
global___ImportIPC2581Request = ImportIPC2581Request

class DeleteProjectRequest(google.protobuf.message.Message):
    """*
    Request for deleting project
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    PROJECT_FIELD_NUMBER: builtins.int
    project: typing.Text = ...
    """Project name of project to be deleted"""

    def __init__(self,
        *,
        project : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["project",b"project"]) -> None: ...
global___DeleteProjectRequest = DeleteProjectRequest

class AddStrainMapRequest(google.protobuf.message.Message):
    """*
    Request to add a strain map CSV file
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class StrainMapFile(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        STRAINMAPFILE_FIELD_NUMBER: builtins.int
        FILECOMMENT_FIELD_NUMBER: builtins.int
        HEADERROWCOUNT_FIELD_NUMBER: builtins.int
        REFERENCEIDCOLUMN_FIELD_NUMBER: builtins.int
        STRAINCOLUMN_FIELD_NUMBER: builtins.int
        STRAINUNITS_FIELD_NUMBER: builtins.int
        CCA_FIELD_NUMBER: builtins.int
        strainMapFile: typing.Text = ...
        """Full path to the strain map file to be added."""

        fileComment: typing.Text = ...
        """File comment text."""

        headerRowCount: builtins.int = ...
        """Number of rows before the column header in the file."""

        referenceIDColumn: typing.Text = ...
        """Reference ID column name."""

        strainColumn: typing.Text = ...
        """Strain column name."""

        strainUnits: typing.Text = ...
        """Strain units used in the strain map file. Valid units: µε, ε"""

        @property
        def cca(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[typing.Text]:
            """Project CCA names to to add the file to."""
            pass
        def __init__(self,
            *,
            strainMapFile : typing.Text = ...,
            fileComment : typing.Text = ...,
            headerRowCount : builtins.int = ...,
            referenceIDColumn : typing.Text = ...,
            strainColumn : typing.Text = ...,
            strainUnits : typing.Text = ...,
            cca : typing.Optional[typing.Iterable[typing.Text]] = ...,
            ) -> None: ...
        def ClearField(self, field_name: typing_extensions.Literal["cca",b"cca","fileComment",b"fileComment","headerRowCount",b"headerRowCount","referenceIDColumn",b"referenceIDColumn","strainColumn",b"strainColumn","strainMapFile",b"strainMapFile","strainUnits",b"strainUnits"]) -> None: ...

    PROJECT_FIELD_NUMBER: builtins.int
    STRAINMAPFILES_FIELD_NUMBER: builtins.int
    project: typing.Text = ...
    """Sherlock project name."""

    @property
    def strainMapFiles(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___AddStrainMapRequest.StrainMapFile]:
        """Strain map files and associated properties to be added."""
        pass
    def __init__(self,
        *,
        project : typing.Text = ...,
        strainMapFiles : typing.Optional[typing.Iterable[global___AddStrainMapRequest.StrainMapFile]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["project",b"project","strainMapFiles",b"strainMapFiles"]) -> None: ...
global___AddStrainMapRequest = AddStrainMapRequest

class AddStrainMapResponse(google.protobuf.message.Message):
    """*
    Response from adding strain map CSV files
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    RETURNCODE_FIELD_NUMBER: builtins.int
    ERRORS_FIELD_NUMBER: builtins.int
    @property
    def returnCode(self) -> ansys.api.sherlock.v0.SherlockCommonService_pb2.ReturnCode:
        """Status code of response."""
        pass
    @property
    def errors(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[typing.Text]:
        """List of validation errors."""
        pass
    def __init__(self,
        *,
        returnCode : typing.Optional[ansys.api.sherlock.v0.SherlockCommonService_pb2.ReturnCode] = ...,
        errors : typing.Optional[typing.Iterable[typing.Text]] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["returnCode",b"returnCode"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["errors",b"errors","returnCode",b"returnCode"]) -> None: ...
global___AddStrainMapResponse = AddStrainMapResponse

class ListStrainMapsRequest(google.protobuf.message.Message):
    """*
    Request to list CCA strain maps for a project
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    PROJECT_FIELD_NUMBER: builtins.int
    CCA_FIELD_NUMBER: builtins.int
    project: typing.Text = ...
    """Sherlock project name."""

    @property
    def cca(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[typing.Text]:
        """Optional project CCA names to list strain maps for."""
        pass
    def __init__(self,
        *,
        project : typing.Text = ...,
        cca : typing.Optional[typing.Iterable[typing.Text]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["cca",b"cca","project",b"project"]) -> None: ...
global___ListStrainMapsRequest = ListStrainMapsRequest

class ListStrainMapsResponse(google.protobuf.message.Message):
    """*
    Lists the strain maps assigned to the project CCA's.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class CcaStrainMap(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        CCANAME_FIELD_NUMBER: builtins.int
        STRAINMAPS_FIELD_NUMBER: builtins.int
        ccaName: typing.Text = ...
        """Name of the CCA."""

        @property
        def strainMaps(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[typing.Text]:
            """Strain map names assigned to the CCA."""
            pass
        def __init__(self,
            *,
            ccaName : typing.Text = ...,
            strainMaps : typing.Optional[typing.Iterable[typing.Text]] = ...,
            ) -> None: ...
        def ClearField(self, field_name: typing_extensions.Literal["ccaName",b"ccaName","strainMaps",b"strainMaps"]) -> None: ...

    RETURNCODE_FIELD_NUMBER: builtins.int
    ERRORS_FIELD_NUMBER: builtins.int
    CCASTRAINMAPS_FIELD_NUMBER: builtins.int
    @property
    def returnCode(self) -> ansys.api.sherlock.v0.SherlockCommonService_pb2.ReturnCode:
        """Status code of response."""
        pass
    @property
    def errors(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[typing.Text]:
        """List of errors encountered."""
        pass
    @property
    def ccaStrainMaps(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ListStrainMapsResponse.CcaStrainMap]:
        """CCA strain maps assigned to the project."""
        pass
    def __init__(self,
        *,
        returnCode : typing.Optional[ansys.api.sherlock.v0.SherlockCommonService_pb2.ReturnCode] = ...,
        errors : typing.Optional[typing.Iterable[typing.Text]] = ...,
        ccaStrainMaps : typing.Optional[typing.Iterable[global___ListStrainMapsResponse.CcaStrainMap]] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["returnCode",b"returnCode"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["ccaStrainMaps",b"ccaStrainMaps","errors",b"errors","returnCode",b"returnCode"]) -> None: ...
global___ListStrainMapsResponse = ListStrainMapsResponse

class ListCCAsRequest(google.protobuf.message.Message):
    """*
    Request to list CCA's and sub-assembly CCA's for a project
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    PROJECT_FIELD_NUMBER: builtins.int
    CCA_FIELD_NUMBER: builtins.int
    project: typing.Text = ...
    """Sherlock project name."""

    @property
    def cca(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[typing.Text]:
        """Optional project CCA names to return."""
        pass
    def __init__(self,
        *,
        project : typing.Text = ...,
        cca : typing.Optional[typing.Iterable[typing.Text]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["cca",b"cca","project",b"project"]) -> None: ...
global___ListCCAsRequest = ListCCAsRequest

class ListCCAsResponse(google.protobuf.message.Message):
    """*
    Represents the circuit cards, their properties, and sub-assemblies for a Sherlock project.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class CCA(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        CCANAME_FIELD_NUMBER: builtins.int
        SUBASSEMBLIES_FIELD_NUMBER: builtins.int
        ccaName: typing.Text = ...
        """Name of the CCA."""

        @property
        def subAssemblies(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ListCCAsResponse.CCA]:
            """Sub-assemblies assigned to the CCA."""
            pass
        def __init__(self,
            *,
            ccaName : typing.Text = ...,
            subAssemblies : typing.Optional[typing.Iterable[global___ListCCAsResponse.CCA]] = ...,
            ) -> None: ...
        def ClearField(self, field_name: typing_extensions.Literal["ccaName",b"ccaName","subAssemblies",b"subAssemblies"]) -> None: ...

    RETURNCODE_FIELD_NUMBER: builtins.int
    CCAS_FIELD_NUMBER: builtins.int
    @property
    def returnCode(self) -> ansys.api.sherlock.v0.SherlockCommonService_pb2.ReturnCode:
        """Status code of response."""
        pass
    @property
    def ccas(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ListCCAsResponse.CCA]:
        """CCA's assigned to the project."""
        pass
    def __init__(self,
        *,
        returnCode : typing.Optional[ansys.api.sherlock.v0.SherlockCommonService_pb2.ReturnCode] = ...,
        ccas : typing.Optional[typing.Iterable[global___ListCCAsResponse.CCA]] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["returnCode",b"returnCode"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["ccas",b"ccas","returnCode",b"returnCode"]) -> None: ...
global___ListCCAsResponse = ListCCAsResponse
